<xsl:stylesheet version="2.0" 
    xmlns:xsl="http://www.w3.org/1999/XSL/Transform" 
    xmlns:ss="urn:schemas-microsoft-com:office:spreadsheet" 
    xmlns:xalan="http://xml.apache.org/xalan" 
    xmlns:functx="http://www.functx.com"
    xmlns="urn:schemas-microsoft-com:office:excel"
    >
   
	<xsl:param name="includedFile"/>
	<xsl:output method="xml" version="1.0"  encoding="UTF-8" indent="yes" omit-xml-declaration="no" />
	
	
	<!-- Template used to preserve the new line characters (&#10;) of the InputMessage elements -->
    <xsl:template match="text()" name="replaceNL">
      <xsl:param name="pText" select="."/>
      <xsl:choose>
        <xsl:when test="contains($pText, '&#xA;')">
          <xsl:value-of select="substring-before($pText, '&#xA;')"/>
              <xsl:text disable-output-escaping="yes">&amp;#10;</xsl:text>
          <xsl:call-template name="replaceNL">
            <xsl:with-param name="pText" select="substring-after($pText, '&#xA;')"/>
          </xsl:call-template>
        </xsl:when>
        <xsl:otherwise>
          <xsl:value-of select="$pText"/>
        </xsl:otherwise>
      </xsl:choose>
     </xsl:template>
	
	<!--COPY NODES AND STRUCTURES (identical transformation)-->
	<xsl:template match="@*|node()">
        <xsl:if test="name()!='InputMessage'">
            <xsl:copy>
                <xsl:apply-templates select="@*|node()"/>
            </xsl:copy>
		</xsl:if>
		<xsl:if test="name()='InputMessage'">
            <xsl:copy>
                <xsl:call-template name="replaceNL"/>
            </xsl:copy>
		</xsl:if>
	</xsl:template>
	
		<xsl:template name="insertDefaultStyle">
						<xsl:text disable-output-escaping="yes">
   &lt;Style  xmlns="urn:schemas-microsoft-com:office:spreadsheet" xmlns:html="http://www.w3.org/TR/REC-html40" xmlns:o="urn:schemas-microsoft-com:office:office" xmlns:ss="urn:schemas-microsoft-com:office:spreadsheet" xmlns:x="urn:schemas-microsoft-com:office:excel" ss:ID="Default" &gt;
   &lt;Alignment ss:Horizontal="Center" ss:Vertical="Bottom"/&gt;
   &lt;Borders/&gt;
   &lt;Font ss:FontName="Calibri" x:Family="Swiss" ss:Size="11" ss:Color="#000000"/&gt;
   &lt;Interior /&gt;
   &lt;NumberFormat ss:Format="@" /&gt;
   &lt;Protection/&gt;
  &lt;/Style&gt;
		</xsl:text>
	</xsl:template>	

	<xsl:template name="insertStyle">
						<xsl:text disable-output-escaping="yes">
&lt;Style xmlns="urn:schemas-microsoft-com:office:spreadsheet" xmlns:html="http://www.w3.org/TR/REC-html40" xmlns:o="urn:schemas-microsoft-com:office:office" xmlns:ss="urn:schemas-microsoft-com:office:spreadsheet" xmlns:x="urn:schemas-microsoft-com:office:excel" ss:ID="UABSTYLEHIDDEN"&gt;
   &lt;Font ss:FontName="Calibri" x:Family="Swiss" ss:Size="11" ss:Color="#A5A5A5"/&gt;
  &lt;/Style&gt;	
  &lt;Style xmlns="urn:schemas-microsoft-com:office:spreadsheet" xmlns:html="http://www.w3.org/TR/REC-html40" xmlns:o="urn:schemas-microsoft-com:office:office" xmlns:ss="urn:schemas-microsoft-com:office:spreadsheet" xmlns:x="urn:schemas-microsoft-com:office:excel" ss:ID="UABSTYLEProjectDocumentation"&gt;
   &lt;Alignment ss:Horizontal="Center" ss:Vertical="Bottom"/&gt;
   &lt;Borders&gt;
    &lt;Border ss:Position="Bottom" ss:LineStyle="Continuous" ss:Weight="1"/&gt;
    &lt;Border ss:Position="Left" ss:LineStyle="Continuous" ss:Weight="1"/&gt;
    &lt;Border ss:Position="Right" ss:LineStyle="Continuous" ss:Weight="1"/&gt;
    &lt;Border ss:Position="Top" ss:LineStyle="Continuous" ss:Weight="1"/&gt;
   &lt;/Borders&gt;
   &lt;Font x:CharSet="204" x:Family="Swiss" ss:Bold="1"/&gt;
   &lt;/Style&gt;					
  &lt;Style xmlns="urn:schemas-microsoft-com:office:spreadsheet" xmlns:html="http://www.w3.org/TR/REC-html40" xmlns:o="urn:schemas-microsoft-com:office:office" xmlns:ss="urn:schemas-microsoft-com:office:spreadsheet" xmlns:x="urn:schemas-microsoft-com:office:excel" ss:ID="UABSTYLEProjectDocumentationUnprotected"&gt;
   &lt;Alignment ss:Horizontal="Center" ss:Vertical="Bottom"/&gt;
   &lt;Borders&gt;
    &lt;Border ss:Position="Bottom" ss:LineStyle="Continuous" ss:Weight="1"/&gt;
    &lt;Border ss:Position="Left" ss:LineStyle="Continuous" ss:Weight="1"/&gt;
    &lt;Border ss:Position="Right" ss:LineStyle="Continuous" ss:Weight="1"/&gt;
    &lt;Border ss:Position="Top" ss:LineStyle="Continuous" ss:Weight="1"/&gt;
   &lt;/Borders&gt;
   &lt;Font x:CharSet="204" x:Family="Swiss" ss:Bold="1"/&gt;
   &lt;Protection ss:Protected="0"/&gt;   
   &lt;/Style&gt;		
  &lt;Style xmlns="urn:schemas-microsoft-com:office:spreadsheet" xmlns:html="http://www.w3.org/TR/REC-html40" xmlns:o="urn:schemas-microsoft-com:office:office" xmlns:ss="urn:schemas-microsoft-com:office:spreadsheet" xmlns:x="urn:schemas-microsoft-com:office:excel" ss:ID="UABSTYLE1"&gt;
   &lt;Alignment ss:Horizontal="Center" ss:Vertical="Bottom"/&gt;
   &lt;Borders&gt;
    &lt;Border ss:Position="Bottom" ss:LineStyle="Continuous" ss:Weight="1"/&gt;
    &lt;Border ss:Position="Left" ss:LineStyle="Continuous" ss:Weight="1"/&gt;
    &lt;Border ss:Position="Right" ss:LineStyle="Continuous" ss:Weight="1"/&gt;
    &lt;Border ss:Position="Top" ss:LineStyle="Continuous" ss:Weight="1"/&gt;
   &lt;/Borders&gt;
   &lt;Font x:CharSet="204" x:Family="Swiss" ss:Bold="1"/&gt;
   &lt;Interior ss:Color="#FFCC99" ss:Pattern="Solid"/&gt;
  &lt;/Style&gt;
  &lt;Style xmlns="urn:schemas-microsoft-com:office:spreadsheet" xmlns:html="http://www.w3.org/TR/REC-html40" xmlns:o="urn:schemas-microsoft-com:office:office" xmlns:ss="urn:schemas-microsoft-com:office:spreadsheet" xmlns:x="urn:schemas-microsoft-com:office:excel" ss:ID="UABSTYLE1_Required" ss:Parent="UABSTYLE1"&gt;
   &lt;Font x:CharSet="204" x:Family="Swiss" ss:Color="#FF0000" ss:Bold="1"/&gt;
  &lt;/Style&gt;
  &lt;Style xmlns="urn:schemas-microsoft-com:office:spreadsheet" xmlns:html="http://www.w3.org/TR/REC-html40" xmlns:o="urn:schemas-microsoft-com:office:office" xmlns:ss="urn:schemas-microsoft-com:office:spreadsheet" xmlns:x="urn:schemas-microsoft-com:office:excel" ss:ID="UABSTYLE2" ss:Parent="UABSTYLE1"&gt;
   &lt;Interior ss:Color="#FFFF99" ss:Pattern="Solid"/&gt;
  &lt;/Style&gt;
  &lt;Style xmlns="urn:schemas-microsoft-com:office:spreadsheet" xmlns:html="http://www.w3.org/TR/REC-html40" xmlns:o="urn:schemas-microsoft-com:office:office" xmlns:ss="urn:schemas-microsoft-com:office:spreadsheet" xmlns:x="urn:schemas-microsoft-com:office:excel" ss:ID="UABSTYLE2_Required" ss:Parent="UABSTYLE2"&gt;
   &lt;Font x:CharSet="204" x:Family="Swiss" ss:Color="#FF0000" ss:Bold="1"/&gt;
  &lt;/Style&gt;  
  &lt;Style xmlns="urn:schemas-microsoft-com:office:spreadsheet" xmlns:html="http://www.w3.org/TR/REC-html40" xmlns:o="urn:schemas-microsoft-com:office:office" xmlns:ss="urn:schemas-microsoft-com:office:spreadsheet" xmlns:x="urn:schemas-microsoft-com:office:excel" ss:ID="UABSTYLE3" ss:Parent="UABSTYLE1"&gt;
   &lt;Interior ss:Color="#CCFFCC" ss:Pattern="Solid"/&gt;
  &lt;/Style&gt;
  &lt;Style xmlns="urn:schemas-microsoft-com:office:spreadsheet" xmlns:html="http://www.w3.org/TR/REC-html40" xmlns:o="urn:schemas-microsoft-com:office:office" xmlns:ss="urn:schemas-microsoft-com:office:spreadsheet" xmlns:x="urn:schemas-microsoft-com:office:excel" ss:ID="UABSTYLE3_Required" ss:Parent="UABSTYLE3"&gt;
   &lt;Font x:CharSet="204" x:Family="Swiss" ss:Color="#FF0000" ss:Bold="1"/&gt;
  &lt;/Style&gt;  
  &lt;Style xmlns="urn:schemas-microsoft-com:office:spreadsheet" xmlns:html="http://www.w3.org/TR/REC-html40" xmlns:o="urn:schemas-microsoft-com:office:office" xmlns:ss="urn:schemas-microsoft-com:office:spreadsheet" xmlns:x="urn:schemas-microsoft-com:office:excel" ss:ID="UABSTYLE4" ss:Parent="UABSTYLE1"&gt;
   &lt;Interior ss:Color="#CCFFFF" ss:Pattern="Solid"/&gt;
  &lt;/Style&gt;
  &lt;Style xmlns="urn:schemas-microsoft-com:office:spreadsheet" xmlns:html="http://www.w3.org/TR/REC-html40" xmlns:o="urn:schemas-microsoft-com:office:office" xmlns:ss="urn:schemas-microsoft-com:office:spreadsheet" xmlns:x="urn:schemas-microsoft-com:office:excel" ss:ID="UABSTYLE4_Required" ss:Parent="UABSTYLE4"&gt;
   &lt;Font x:CharSet="204" x:Family="Swiss" ss:Color="#FF0000" ss:Bold="1"/&gt;
  &lt;/Style&gt;  
    &lt;Style xmlns="urn:schemas-microsoft-com:office:spreadsheet" xmlns:html="http://www.w3.org/TR/REC-html40" xmlns:o="urn:schemas-microsoft-com:office:office" xmlns:ss="urn:schemas-microsoft-com:office:spreadsheet" xmlns:x="urn:schemas-microsoft-com:office:excel" ss:ID="UABSTYLE5" ss:Parent="UABSTYLE1"&gt;
   &lt;Interior ss:Color="#99CCFF" ss:Pattern="Solid"/&gt;
  &lt;/Style&gt;
    &lt;Style xmlns="urn:schemas-microsoft-com:office:spreadsheet" xmlns:html="http://www.w3.org/TR/REC-html40" xmlns:o="urn:schemas-microsoft-com:office:office" xmlns:ss="urn:schemas-microsoft-com:office:spreadsheet" xmlns:x="urn:schemas-microsoft-com:office:excel" ss:ID="UABSTYLE5_Required" ss:Parent="UABSTYLE5"&gt;
   &lt;Font x:CharSet="204" x:Family="Swiss" ss:Color="#FF0000" ss:Bold="1"/&gt;
  &lt;/Style&gt;  
  &lt;Style xmlns="urn:schemas-microsoft-com:office:spreadsheet" xmlns:html="http://www.w3.org/TR/REC-html40" xmlns:o="urn:schemas-microsoft-com:office:office" xmlns:ss="urn:schemas-microsoft-com:office:spreadsheet" xmlns:x="urn:schemas-microsoft-com:office:excel" ss:ID="UnprotectedUABSTYLE"&gt;
   &lt;Alignment ss:Horizontal="Center" ss:Vertical="Bottom"/&gt;
   &lt;Borders/&gt;
   &lt;Font ss:FontName="Calibri" x:Family="Swiss" ss:Size="11" ss:Color="#000000"/&gt;
   &lt;Interior/&gt;   
   &lt;NumberFormat ss:Format="@"/&gt;
   &lt;Protection ss:Protected="0"/&gt;   
  &lt;/Style&gt;  
  &lt;Style xmlns="urn:schemas-microsoft-com:office:spreadsheet" xmlns:html="http://www.w3.org/TR/REC-html40" xmlns:o="urn:schemas-microsoft-com:office:office" xmlns:ss="urn:schemas-microsoft-com:office:spreadsheet" xmlns:x="urn:schemas-microsoft-com:office:excel" ss:ID="HyperlinkUABSTYLE"&gt;
   &lt;Font ss:FontName="Calibri" x:Family="Swiss" ss:Size="11" ss:Color="#0000FF" ss:Underline="Single"/&gt;
  &lt;/Style&gt;  
&lt;Style xmlns="urn:schemas-microsoft-com:office:spreadsheet" xmlns:html="http://www.w3.org/TR/REC-html40" xmlns:o="urn:schemas-microsoft-com:office:office" xmlns:ss="urn:schemas-microsoft-com:office:spreadsheet" xmlns:x="urn:schemas-microsoft-com:office:excel" ss:ID="s30UABSTYLE"&gt;
   &lt;Font x:CharSet="204" x:Family="Swiss"/&gt;
  &lt;/Style&gt;
</xsl:text>
	</xsl:template>
	
	<xsl:template name="printRow">
		<xsl:param name="level"/>
		<xsl:param name="styleId"/>
		<xsl:for-each select="Attribute|AttributeFamily">
			<xsl:if test="$level > 2"> 
				<xsl:if test="count(.//Attribute[count(Attribute)=0])=0 and count(isSpecificationAttribute)>0">
					<xsl:text disable-output-escaping="yes">&lt;Cell</xsl:text> ss:StyleID="UABSTYLE<xsl:value-of select="$styleId"/><xsl:text disable-output-escaping="yes">"&gt;&lt;/Cell&gt;</xsl:text>
				</xsl:if>
				<xsl:call-template name="printRow"> 
					<xsl:with-param name="level" select="$level - 1"/>
					<xsl:with-param name="styleId" select="$styleId"/>
				</xsl:call-template>
			</xsl:if>
			<xsl:if test="$level = 2">
				<xsl:if test="count(.//Attribute[count(Attribute)=0][count(isSpecificationAttribute)>0])>0">
					<xsl:text disable-output-escaping="yes">&lt;Cell </xsl:text>
					<xsl:if test="count(.//Attribute[count(Attribute)=0][count(isSpecificationAttribute)>0])>1"> ss:MergeAcross="<xsl:value-of select="count(.//Attribute[count(Attribute)=0][count(isSpecificationAttribute)>0])-1"/>"</xsl:if> ss:StyleID="UABSTYLE<xsl:value-of select="$styleId"/><xsl:text disable-output-escaping="yes">"&gt;&lt;Data ss:Type="String"&gt;</xsl:text>
						<xsl:choose>
							<xsl:when test="count(isSpecificationAttribute/NameRepresentation)>0">
								<xsl:value-of select="isSpecificationAttribute/NameRepresentation"/>
							</xsl:when>
							<xsl:otherwise>
								<xsl:value-of select="AttributeName"/>
								<xsl:value-of select="AttributeFamilyName"/>
							</xsl:otherwise>
						</xsl:choose>
						<xsl:text disable-output-escaping="yes">&lt;/Data&gt;</xsl:text>
							<xsl:if test="Description!=''">
								<xsl:text disable-output-escaping="yes">&lt;Comment&gt;&lt;ss:Data xmlns="http://www.w3.org/TR/REC-html40"&gt;</xsl:text><xsl:value-of select="Description"/><xsl:text disable-output-escaping="yes">&lt;/ss:Data&gt;&lt;/Comment&gt;</xsl:text>
							</xsl:if>
						<xsl:text disable-output-escaping="yes">&lt;/Cell&gt;</xsl:text>
					</xsl:if>
					<xsl:if test="count(.//Attribute[count(Attribute)=0])=0 and count(isSpecificationAttribute)>0">
						<xsl:text disable-output-escaping="yes">&lt;Cell </xsl:text> ss:StyleID="UABSTYLE<xsl:value-of select="$styleId"/><xsl:text disable-output-escaping="yes">"&gt;&lt;/Cell&gt;</xsl:text>
				</xsl:if>
			</xsl:if>
		</xsl:for-each>
	</xsl:template>

	<!-- UCPC-627 Add template for replace-substring per Ivan -->
	<xsl:template name="replace-substring">
		<xsl:param name="original"/>
		<xsl:param name="substring"/>
		<xsl:param name="replacement" select="''"/>
		<xsl:choose>
			<xsl:when test="contains($original, $substring)">
				<xsl:value-of select="substring-before($original, $substring)"/>
				<xsl:value-of select="$replacement"/>
				<xsl:call-template name="replace-substring">
					<xsl:with-param name="original" select="substring-after($original, $substring)"/>
					<xsl:with-param name="substring" select="$substring"/>
					<xsl:with-param name="replacement" select="$replacement"/>
				</xsl:call-template>
			</xsl:when>
			<xsl:otherwise>
				<xsl:value-of select="$original"/>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>


	<xsl:template match="/">
		<xsl:variable name="included">
			<xsl:if test="$includedFile!=''">
				<xsl:copy-of select="document($includedFile)"/>
			</xsl:if>
		</xsl:variable>
		
		<!-- Get the row number where the device header table starts -->
		<xsl:variable name="header-start">		
		  <xsl:for-each select="//Information">
			   <xsl:copy-of select="count(child::*)+2"/>
			</xsl:for-each>
		</xsl:variable>			
		
 
        <xsl:text disable-output-escaping="yes">
&lt;?mso-application progid="Excel.Sheet"?&gt;
&lt;Workbook </xsl:text>
        
        <!-- Add the resources package name and version from the included file -->
		<xsl:if test="$includedFile!=''">
            <xsl:variable name="resourcesName">
                <xsl:value-of select="document($includedFile)//@ss:ResourcesPackageName"></xsl:value-of>
            </xsl:variable>
            <xsl:variable name="resourcesVersion">
                <xsl:value-of select="document($includedFile)//@ss:ResourcesPackageVersion"></xsl:value-of>
            </xsl:variable>
            <xsl:text disable-output-escaping="yes">ss:ResourcesPackageName="</xsl:text>
            <xsl:value-of select="$resourcesName"/>
            <xsl:text disable-output-escaping="yes">" ss:ResourcesPackageVersion="</xsl:text>
            <xsl:value-of select="$resourcesVersion"/>
            <xsl:text disable-output-escaping="yes">" </xsl:text>
        </xsl:if>         
        
        <xsl:text disable-output-escaping="yes">
        xmlns="urn:schemas-microsoft-com:office:spreadsheet"
 xmlns:o="urn:schemas-microsoft-com:office:office"
 xmlns:x="urn:schemas-microsoft-com:office:excel"
 xmlns:ss="urn:schemas-microsoft-com:office:spreadsheet"
 xmlns:html="http://www.w3.org/TR/REC-html40"&gt;
 &lt;DocumentProperties xmlns="urn:schemas-microsoft-com:office:office"&gt;
  &lt;Author&gt;dmitrif&lt;/Author&gt;
  &lt;LastAuthor&gt;iprietob&lt;/LastAuthor&gt;
  &lt;Created&gt;2009-05-04T16:42:08Z&lt;/Created&gt;
  &lt;LastSaved&gt;2009-05-05T09:22:31Z&lt;/LastSaved&gt;
  &lt;Company&gt;CERN&lt;/Company&gt;
  &lt;Version&gt;11.9999&lt;/Version&gt;
 &lt;/DocumentProperties&gt;
 &lt;ExcelWorkbook xmlns="urn:schemas-microsoft-com:office:excel"&gt;
  &lt;WindowHeight&gt;12660&lt;/WindowHeight&gt;
  &lt;WindowWidth&gt;19020&lt;/WindowWidth&gt;
  &lt;WindowTopX&gt;120&lt;/WindowTopX&gt;
  &lt;WindowTopY&gt;105&lt;/WindowTopY&gt;
  &lt;ProtectStructure&gt;False&lt;/ProtectStructure&gt;
  &lt;ProtectWindows&gt;False&lt;/ProtectWindows&gt;
 &lt;/ExcelWorkbook&gt;
  &lt;Styles&gt;
         </xsl:text>

 
 <xsl:if test="$includedFile!=''"><!--COPY STYLES FROM FILE TO BE INCLUDED (but the default style) -->
 		<xsl:for-each select="xalan:nodeset($included)//*[name()='Style'][@ss:ID != 'Default']">
			<xsl:copy>
				<xsl:apply-templates select="@*|node()"/>
			</xsl:copy>
		</xsl:for-each>
		<!-- Add the default style -->
		<xsl:call-template name="insertDefaultStyle"/>
</xsl:if>
<!--CREATE DEFAULT STYLE-->
 <xsl:if test="$includedFile=''">
			<xsl:call-template name="insertDefaultStyle"/>
			<xsl:call-template name="insertStyle"/>
</xsl:if>
		<!--check if we already have UAB styles (it could be if file to include was generated using this xslt)-->
		<xsl:if test="$includedFile!=''">
			<xsl:if test="count(xalan:nodeset($included)//*[name()='Style'][@ss:ID='UABSTYLE1']|xalan:nodeset($included)//*[name()='Style'][@ss:ID='UABSTYLE2']|xalan:nodeset($included)//*[name()='Style'][@ss:ID='UABSTYLE3']|xalan:nodeset($included)//*[name()='Style'][@ss:ID='UABSTYLE4']|xalan:nodeset($included)//*[name()='Style'][@ss:ID='UABSTYLE5']|xalan:nodeset($included)//*[name()='Style'][@ss:ID='s30UABSTYLE'])=0">
				<xsl:call-template name="insertStyle"/>
			</xsl:if>
		</xsl:if>	
		
<xsl:text disable-output-escaping="yes">&lt;/Styles&gt;</xsl:text>
	

<!-- Copy the Names node from the included file -->
 <xsl:if test="$includedFile!=''">
     <xsl:text disable-output-escaping="yes">
     &lt;Names&gt;</xsl:text>
 		<xsl:for-each select="xalan:nodeset($included)/*[name()='Workbook']/*[name()='Names']/*">
			<xsl:copy>
				<xsl:apply-templates select="@*|node()"/>
			</xsl:copy>
		</xsl:for-each>
		<xsl:text disable-output-escaping="yes">&lt;/Names&gt;</xsl:text>
</xsl:if>



		
<xsl:if test="$includedFile=''"><!--If creating new workbook, add Title Page-->
                        <xsl:text disable-output-escaping="yes"><![CDATA[ 
                        <Worksheet xmlns="urn:schemas-microsoft-com:office:spreadsheet" xmlns:html="http://www.w3.org/TR/REC-html40" xmlns:o="urn:schemas-microsoft-com:office:office" xmlns:ss="urn:schemas-microsoft-com:office:spreadsheet" xmlns:x="urn:schemas-microsoft-com:office:excel" ss:Protected="1" ss:Name="ProjectDocumentation">
	 <Table ss:ExpandedColumnCount="5" x:FullColumns="1"
   x:FullRows="1" ss:DefaultRowHeight="15" ss:HeaderStart="9" ss:HeaderEnd="9" ss:StyleID="UnprotectedUABSTYLE" >
   <Column ss:Width="120.75"/>
   <Column ss:AutoFitWidth="0" ss:Width="90.75"/>
   <Column ss:AutoFitWidth="0" ss:Width="282"/>
   <Column ss:AutoFitWidth="0" ss:Width="60.75"/>
   <Column ss:AutoFitWidth="0" ss:Width="61.5"/>
   <Row ss:AutoFitHeight="0">
    <Cell ss:StyleID="UABSTYLEProjectDocumentation"><Data ss:Type="String">Project Name:</Data></Cell>
    <Cell ss:StyleID="UABSTYLEProjectDocumentationUnprotected" ss:MergeAcross="3"><Data ss:Type="String"></Data></Cell>
   </Row>
   <Row ss:AutoFitHeight="0">
    <Cell ss:StyleID="UABSTYLEProjectDocumentation"><Data ss:Type="String">Application Name:</Data></Cell>
    <Cell ss:StyleID="UABSTYLEProjectDocumentationUnprotected" ss:MergeAcross="3"><Data ss:Type="String"></Data></Cell>
   </Row>
   <Row ss:AutoFitHeight="0">
    <Cell ss:StyleID="UABSTYLEProjectDocumentation"><Data ss:Type="String">Project Description:</Data></Cell>
    <Cell ss:StyleID="UABSTYLEProjectDocumentationUnprotected" ss:MergeAcross="3"><Data ss:Type="String"></Data></Cell>
   </Row>
   <Row ss:AutoFitHeight="0">
    <Cell ss:StyleID="UABSTYLEProjectDocumentation"><Data ss:Type="String">Project Owner:</Data></Cell>
    <Cell ss:StyleID="UABSTYLEProjectDocumentationUnprotected" ss:MergeAcross="3"><Data ss:Type="String"></Data></Cell>
   </Row>
   <Row ss:AutoFitHeight="0">
    <Cell ss:StyleID="UABSTYLEProjectDocumentation"><Data ss:Type="String">Spec FAQ link:</Data></Cell>
    <Cell ss:MergeAcross="3" ss:StyleID="UABSTYLEProjectDocumentation" ss:HRef="http://cern.ch/UNICOS-SpecFAQ"><Data
      ss:Type="String">http://cern.ch/UNICOS-SpecFAQ</Data></Cell>
   </Row>
   <Row ss:AutoFitHeight="0">
    <Cell ss:StyleID="UABSTYLEProjectDocumentation"><Data ss:Type="String">Object Descriptions link:</Data></Cell>
    <Cell ss:MergeAcross="3" ss:StyleID="UABSTYLEProjectDocumentation" ss:HRef="http://cern.ch/UNICOS-ObjectDescription"><Data
      ss:Type="String">http://cern.ch/UNICOS-ObjectDescription</Data></Cell>
   </Row>
   <Row/>
   <Row ss:AutoFitHeight="0">
    <Cell ss:StyleID="UABSTYLEProjectDocumentation"><Data ss:Type="String">Spec Changes:</Data></Cell>
    <Cell ss:MergeAcross="3" />
   </Row>
   <Row ss:AutoFitHeight="0">
    <Cell ss:StyleID="UABSTYLEProjectDocumentation"><Data ss:Type="String">Date</Data></Cell>
    <Cell ss:StyleID="UABSTYLEProjectDocumentation"><Data ss:Type="String">User</Data></Cell>
    <Cell ss:StyleID="UABSTYLEProjectDocumentation"><Data ss:Type="String">Comments</Data></Cell>
    <Cell ss:StyleID="UABSTYLEProjectDocumentation"><Data ss:Type="String">Version</Data></Cell>
    <Cell ss:StyleID="UABSTYLEProjectDocumentation"><Data ss:Type="String">HTML link</Data></Cell>
   </Row>
  </Table>
  <WorksheetOptions xmlns="urn:schemas-microsoft-com:office:excel">
   <PageSetup>
    <Header x:Margin="0.3"/>
    <Footer x:Margin="0.3"/>
    <PageMargins x:Bottom="0.75" x:Left="0.7" x:Right="0.7" x:Top="0.75"/>
   </PageSetup>
   <Unsynced/>
   <Selected/>
   <FreezePanes/>
   <FrozenNoSplit/>
   <SplitHorizontal>9</SplitHorizontal>
   <TopRowBottomPane>9</TopRowBottomPane>
   <SplitVertical>1</SplitVertical>
   <LeftColumnRightPane>1</LeftColumnRightPane>
   <ActivePane>0</ActivePane>
   <Panes>
    <Pane>
     <Number>3</Number>
     <ActiveRow>18</ActiveRow>
     <RangeSelection>R19C1:R20C5</RangeSelection>
    </Pane>
   </Panes>
   <ProtectObjects>False</ProtectObjects>
   <ProtectScenarios>False</ProtectScenarios>
   <AllowSizeCols/>
   <AllowSizeRows/>
   <AllowInsertHyperlinks/>
   <AllowSort/>
   <AllowFilter/>
   <AllowFormatCells/>
  </WorksheetOptions>
 </Worksheet>
   ]]></xsl:text>
            </xsl:if><!--transform current xml-->
	<xsl:if test="$includedFile!=''"><!--copy all the worksheets from file to include-->
		<xsl:for-each select="xalan:nodeset($included)//*[name()='Worksheet']">
			<xsl:copy>
				<xsl:apply-templates select="@*|node()"/>
			</xsl:copy>
		</xsl:for-each>
	</xsl:if><!--transform current xml-->
		<xsl:variable name="currentName"> 
			 <xsl:value-of select="UNICOSMetaModel/Information/Name"/> 
		</xsl:variable> 
		<xsl:text disable-output-escaping="yes">&lt;Worksheet xmlns="urn:schemas-microsoft-com:office:spreadsheet" xmlns:html="http://www.w3.org/TR/REC-html40" xmlns:o="urn:schemas-microsoft-com:office:office" xmlns:ss="urn:schemas-microsoft-com:office:spreadsheet" xmlns:x="urn:schemas-microsoft-com:office:excel" ss:Protected="0" ss:IsDeviceType="</xsl:text>
		<xsl:value-of select="$currentName != 'Configuration'"/>
		<xsl:text disable-output-escaping="yes">" ss:Name=</xsl:text>
		<xsl:if test="$includedFile!=''">
			<!-- IF WORKSHEET EXISTS, APPEND "NEW" TO THE NAME-->
			<xsl:if test="count(xalan:nodeset($included)//*[name()='Worksheet'][@ss:Name=$currentName])>0">
				"<xsl:value-of select="UNICOSMetaModel/Information/Name"/>NEW"
			</xsl:if>
			<xsl:if test="count(xalan:nodeset($included)//*[name()='Worksheet'][@ss:Name=$currentName])=0">
				"<xsl:value-of select="UNICOSMetaModel/Information/Name"/>"
			</xsl:if>
		</xsl:if>
		<xsl:if test="$includedFile=''">
				"<xsl:value-of select="UNICOSMetaModel/Information/Name"/>"
		</xsl:if>
		
		<xsl:variable name="header-max-length">
		  <xsl:for-each select="//isSpecificationAttribute">
			  <xsl:sort select="count(ancestor::*)" data-type="number"/>
			  <xsl:if test="position()=last()">
			   <xsl:copy-of select="count(ancestor::*)"/>
			  </xsl:if>
			</xsl:for-each>
		</xsl:variable>	
		
		<xsl:text disable-output-escaping="yes">&gt;
		
  &lt;Table ss:ExpandedColumnCount="256" x:FullColumns="1"
   x:FullRows="1" ss:HeaderStart="</xsl:text><xsl:value-of select="$header-start"/><xsl:text disable-output-escaping="yes">" ss:HeaderEnd="</xsl:text><xsl:value-of select="$header-start + $header-max-length - 2"/><xsl:text disable-output-escaping="yes">" ss:StyleID="UnprotectedUABSTYLE"&gt;
   &lt;Column ss:AutoFitWidth="1" ss:Width="100" ss:Span="255" ss:StyleID="UnprotectedUABSTYLE"/&gt;
   &lt;Row ss:StyleID="s30UABSTYLE"&gt;
    &lt;Cell ss:StyleID="s30UABSTYLE"&gt;&lt;Data ss:Type="String"&gt;Name&lt;/Data&gt;&lt;/Cell&gt;
    &lt;Cell ss:StyleID="s30UABSTYLE"&gt;&lt;Data ss:Type="String"&gt;</xsl:text>
		<xsl:value-of select="UNICOSMetaModel/Information/Name"/>
		<xsl:text disable-output-escaping="yes">&lt;/Data&gt;&lt;/Cell&gt;</xsl:text>
	
		<!-- Write the permitted values for the specification attributes in the first row, from the 8th column -->
		<xsl:text disable-output-escaping="yes">
	&lt;Cell ss:Index="8" ss:StyleID="UABSTYLEHIDDEN"&gt;&lt;Data ss:Type="String"&gt;&lt;/Data&gt;&lt;/Cell&gt;
	&lt;Cell ss:Index="9" ss:StyleID="UABSTYLEHIDDEN"&gt;&lt;Data ss:Type="String"&gt;TRUE&lt;/Data&gt;&lt;/Cell&gt;
	&lt;Cell ss:Index="10" ss:StyleID="UABSTYLEHIDDEN"&gt;&lt;Data ss:Type="String"&gt;FALSE&lt;/Data&gt;&lt;/Cell&gt;
	</xsl:text>
		<xsl:for-each select="UNICOSMetaModel/Attribute|UNICOSMetaModel/AttributeFamily">			
			<xsl:if test="count(.//Attribute/isSpecificationAttribute/PermittedValue)>0">			
				<xsl:for-each select=".//Attribute/isSpecificationAttribute/PermittedValue">
					<xsl:text disable-output-escaping="yes">
	&lt;Cell ss:StyleID="UABSTYLEHIDDEN"&gt;&lt;Data ss:Type="String"&gt;</xsl:text>
					<xsl:value-of select="."/>
					<xsl:text disable-output-escaping="yes">&lt;/Data&gt;&lt;/Cell&gt;</xsl:text>
				</xsl:for-each>				
			</xsl:if>
		</xsl:for-each>
		<!-- End of the permitted values writing -->
		
		<xsl:text disable-output-escaping="yes"> &lt;/Row&gt;</xsl:text>
		
		<!-- Check if the ObjectTypeFamily exists in the device type definition -->
		<xsl:if test="count(//Information/ObjectTypeFamily)>0">
			<xsl:text disable-output-escaping="yes">
   &lt;Row&gt;
    &lt;Cell ss:StyleID="s30UABSTYLE"&gt;&lt;Data ss:Type="String"&gt;Object Type Family&lt;/Data&gt;&lt;/Cell&gt;
    &lt;Cell ss:StyleID="s30UABSTYLE"&gt;&lt;Data ss:Type="String"&gt;</xsl:text>
		<xsl:value-of select="UNICOSMetaModel/Information/ObjectTypeFamily"/>
		<xsl:text disable-output-escaping="yes">&lt;/Data&gt;&lt;/Cell&gt;
   &lt;/Row&gt;</xsl:text>
   </xsl:if>
   
   <xsl:text disable-output-escaping="yes"> 
   &lt;Row &gt;
    &lt;Cell ss:StyleID="s30UABSTYLE"&gt;&lt;Data ss:Type="String"&gt;Description&lt;/Data&gt;&lt;/Cell&gt;
    &lt;Cell ss:StyleID="s30UABSTYLE"&gt;&lt;Data ss:Type="String"&gt;</xsl:text>
		<xsl:value-of select="UNICOSMetaModel/Information/Description"/>
		<xsl:text disable-output-escaping="yes">&lt;/Data&gt;&lt;/Cell&gt;
   &lt;/Row&gt;
   &lt;Row&gt;
    &lt;Cell ss:StyleID="s30UABSTYLE"&gt;&lt;Data ss:Type="String"&gt;Version&lt;/Data&gt;&lt;/Cell&gt;
    &lt;Cell ss:StyleID="s30UABSTYLE"&gt;&lt;Data ss:Type="String"&gt;</xsl:text>
		<xsl:value-of select="UNICOSMetaModel/Information/Version"/>
		<xsl:text disable-output-escaping="yes">&lt;/Data&gt;&lt;/Cell&gt;
   &lt;/Row&gt;
   &lt;Row&gt;
    &lt;Cell ss:StyleID="s30UABSTYLE"&gt;&lt;Data ss:Type="String"&gt;Version Comments&lt;/Data&gt;&lt;/Cell&gt;
    &lt;Cell ss:StyleID="s30UABSTYLE"&gt;&lt;Data ss:Type="String"&gt;</xsl:text>
		<xsl:value-of select="UNICOSMetaModel/Information/VersionComments"/>
		<xsl:text disable-output-escaping="yes">&lt;/Data&gt;&lt;/Cell&gt;
   &lt;/Row&gt;
   &lt;Row&gt;
    &lt;Cell&gt;&lt;Data ss:Type="String"&gt;Status&lt;/Data&gt;&lt;/Cell&gt;
    &lt;Cell ss:StyleID="s30UABSTYLE"&gt;&lt;Data ss:Type="String"&gt;</xsl:text>
		<xsl:value-of select="UNICOSMetaModel/Information/Status"/>
		<xsl:text disable-output-escaping="yes">&lt;/Data&gt;&lt;/Cell&gt;
   &lt;/Row&gt;
</xsl:text>
<!--   &lt;Row&gt;
   &lt;Cell&gt;&lt;Data ss:Type="String"&gt;&lt;/Data&gt;&lt;/Cell&gt;
   &lt;/Row&gt;   -->
	<!-- UCPC-635 Create link from each column in each sheet of the Spec Template to the Spec Documentation sheet (SpecDoc) 
		Do this in row 7 since this row is currently blank and does not distract the user (and so he cannot accidentally click on the link), unlike if we did it in row 10 
		Add this for each column, with updated link, obviously:
		<Cell ss:StyleID="HyperlinkUABSTYLE" ss:HRef="#SpecDoc_AttributeFamily_[AttributeName_]AttributeName" x:HRefScreenTip="Link to help on Attribute (in SpecDoc sheet)"><Data ss:Type="String">Help</Data></Cell>
-->
<xsl:text disable-output-escaping="yes">   &lt;Row&gt;</xsl:text>   
	<xsl:for-each select="UNICOSMetaModel/AttributeFamily[count(//Attribute[count(Attribute)=0][count(isSpecificationAttribute)>0])>0]">
		<xsl:for-each select=".//Attribute[count(Attribute)=0][count(isSpecificationAttribute)>0]">
			<xsl:text disable-output-escaping="yes">&lt;Cell ss:StyleID="HyperlinkUABSTYLE" ss:HRef="#SpecDoc_</xsl:text>
			<xsl:value-of select="ancestor::AttributeFamily/AttributeFamilyName"/><xsl:text disable-output-escaping="yes">_</xsl:text>
			<xsl:choose>
				<xsl:when test="count(ancestor::Attribute/AttributeName)>0"><xsl:value-of select="ancestor::Attribute/AttributeName"/><xsl:text disable-output-escaping="yes">_</xsl:text></xsl:when>
			</xsl:choose>
			<!--Remove spaces from AttributeName, just in case there are any -->
			<xsl:variable name="AttributeNameNoSpaces" >
				<xsl:call-template name="replace-substring">
					<xsl:with-param name="original" select="AttributeName"/>
					<xsl:with-param name="substring" select="' '"/>
					<xsl:with-param name="replacement" select="''"/>
				</xsl:call-template>
			</xsl:variable>
			<xsl:value-of select="$AttributeNameNoSpaces"/>
			<xsl:text disable-output-escaping="yes">" x:HRefScreenTip="Link to help on </xsl:text>
			<xsl:choose>
				<xsl:when test="count(isSpecificationAttribute/NameRepresentation)>0">
					<xsl:value-of select="isSpecificationAttribute/NameRepresentation"/>
				</xsl:when>
				<xsl:otherwise>
					<xsl:value-of select="AttributeName"/>
				</xsl:otherwise>
			</xsl:choose>
			<xsl:text disable-output-escaping="yes">
(in SpecDoc sheet)
*NOTE: Use Alt-LeftArrow to return*"&gt;&lt;Data ss:Type="String"&gt;Help&lt;/Data&gt;&lt;/Cell&gt;</xsl:text>
		</xsl:for-each>
	</xsl:for-each>
	<!-- End add hyperlink -->
<xsl:text disable-output-escaping="yes">&lt;/Row&gt;
   &lt;Row ss:StyleID="s30UABSTYLE"&gt;</xsl:text>
		<!--first level-->
		<xsl:for-each select="UNICOSMetaModel/Attribute|UNICOSMetaModel/AttributeFamily">
			<xsl:if test="count(.//Attribute[count(Attribute)=0][count(isSpecificationAttribute)>0])>0">
				<xsl:text disable-output-escaping="yes">&lt;Cell </xsl:text>
				<xsl:if test="count(.//Attribute[count(Attribute)=0][count(isSpecificationAttribute)>0])>1"> ss:MergeAcross="<xsl:value-of select="count(.//Attribute[count(Attribute)=0][count(isSpecificationAttribute)>0])-1"/>" </xsl:if>
				 ss:StyleID="UABSTYLE<xsl:value-of select="(count(preceding-sibling::*[count(.//isSpecificationAttribute)>0]) mod 5) + 1" />"<xsl:text disable-output-escaping="yes">&gt;&lt;Data ss:Type="String"&gt;</xsl:text> 
				<xsl:choose>
					<xsl:when test="count(isSpecificationAttribute/NameRepresentation)>0">
						<xsl:value-of select="isSpecificationAttribute/NameRepresentation"/>
					</xsl:when>
  					<xsl:otherwise>
						<xsl:value-of select="AttributeName"/>
						<xsl:value-of select="AttributeFamilyName"/>
					</xsl:otherwise>
				</xsl:choose>
				<xsl:text disable-output-escaping="yes">&lt;/Data&gt;</xsl:text>
				<xsl:if test="Description!=''">
					<xsl:text disable-output-escaping="yes">&lt;Comment&gt;&lt;ss:Data xmlns="http://www.w3.org/TR/REC-html40"&gt;</xsl:text><xsl:value-of select="Description"/><xsl:text disable-output-escaping="yes">&lt;/ss:Data&gt;&lt;/Comment&gt;</xsl:text>
				</xsl:if>
				<xsl:text disable-output-escaping="yes">&lt;/Cell&gt;</xsl:text>
			</xsl:if>
		</xsl:for-each>
		<xsl:text disable-output-escaping="yes">&lt;/Row&gt;</xsl:text>
		<!--second level-->
			<xsl:if test="count(UNICOSMetaModel/*/*//Attribute[count(isSpecificationAttribute)>0][count(Attribute)=0])>0">
				<xsl:text disable-output-escaping="yes">&lt;Row ss:StyleID="s30UABSTYLE"&gt;</xsl:text>
				<xsl:for-each select="UNICOSMetaModel/Attribute[count(//Attribute[count(isSpecificationAttribute)>0][count(Attribute)=0])>0]|UNICOSMetaModel/AttributeFamily[count(//Attribute[count(isSpecificationAttribute)>0][count(Attribute)=0])>0]">
					<xsl:call-template name="printRow"> 
						<xsl:with-param name="level" select="2"/> 
						<xsl:with-param name="styleId" select="(count(preceding-sibling::*[count(.//isSpecificationAttribute)>0]) mod 5) + 1"/>
					</xsl:call-template> 
				</xsl:for-each>
				<xsl:text disable-output-escaping="yes">&lt;/Row&gt;</xsl:text>
			</xsl:if>
		<!--third level-->
			<xsl:if test="count(UNICOSMetaModel/*/*/*//Attribute[count(isSpecificationAttribute)>0][count(Attribute)=0])>0">
				<xsl:text disable-output-escaping="yes">&lt;Row ss:StyleID="s30UABSTYLE"&gt;</xsl:text>
				<xsl:for-each select="UNICOSMetaModel/Attribute[count(//Attribute[count(isSpecificationAttribute)>0][count(Attribute)=0])>0]|UNICOSMetaModel/AttributeFamily[count(//Attribute[count(isSpecificationAttribute)>0][count(Attribute)=0])>0]">
					<xsl:call-template name="printRow"> 
						<xsl:with-param name="level" select="3"/> 
						<xsl:with-param name="styleId" select="(count(preceding-sibling::*[count(.//isSpecificationAttribute)>0]) mod 5) + 1"/>
					</xsl:call-template> 
				</xsl:for-each>
				<xsl:text disable-output-escaping="yes">&lt;/Row&gt;</xsl:text>
			</xsl:if>
		<!--fourth level-->
			<xsl:if test="count(UNICOSMetaModel/*/*/*/*//Attribute[count(isSpecificationAttribute)>0][count(Attribute)=0])>0">
				<xsl:text disable-output-escaping="yes">&lt;Row ss:StyleID="s30UABSTYLE"&gt;</xsl:text>
				<xsl:for-each select="UNICOSMetaModel/Attribute[count(//Attribute[count(isSpecificationAttribute)>0][count(Attribute)=0])>0]|UNICOSMetaModel/AttributeFamily[count(//Attribute[count(isSpecificationAttribute)>0][count(Attribute)=0])>0]">
					<xsl:call-template name="printRow"> 
						<xsl:with-param name="level" select="4"/> 
						<xsl:with-param name="styleId" select="(count(preceding-sibling::*[count(.//isSpecificationAttribute)>0]) mod 5) + 1"/>
					</xsl:call-template> 
				</xsl:for-each>
				<xsl:text disable-output-escaping="yes">&lt;/Row&gt;</xsl:text>
			</xsl:if>
		<!--fifth level-->
			<xsl:if test="count(UNICOSMetaModel/*/*/*/*/*//Attribute[count(isSpecificationAttribute)>0][count(Attribute)=0])>0">
				<xsl:text disable-output-escaping="yes">&lt;Row ss:StyleID="s30UABSTYLE"&gt;</xsl:text>
				<xsl:for-each select="UNICOSMetaModel/Attribute[count(//Attribute[count(isSpecificationAttribute)>0][count(Attribute)=0])>0]|UNICOSMetaModel/AttributeFamily[count(//Attribute[count(isSpecificationAttribute)>0][count(Attribute)=0])>0]">
					<xsl:call-template name="printRow"> 
						<xsl:with-param name="level" select="5"/> 
						<xsl:with-param name="styleId" select="(count(preceding-sibling::*[count(.//isSpecificationAttribute)>0]) mod 5) + 1"/>
					</xsl:call-template> 
				</xsl:for-each>
				<xsl:text disable-output-escaping="yes">&lt;/Row&gt;</xsl:text>
			</xsl:if>
		<!--sixth level-->
			<xsl:if test="count(UNICOSMetaModel/*/*/*/*/*/*//Attribute[count(isSpecificationAttribute)>0][count(Attribute)=0])>0">
				<xsl:text disable-output-escaping="yes">&lt;Row ss:StyleID="s30UABSTYLE"&gt;</xsl:text>
				<xsl:for-each select="UNICOSMetaModel/Attribute[count(//Attribute[count(isSpecificationAttribute)>0][count(Attribute)=0])>0]|UNICOSMetaModel/AttributeFamily[count(//Attribute[count(isSpecificationAttribute)>0][count(Attribute)=0])>0]">
					<xsl:call-template name="printRow"> 
						<xsl:with-param name="level" select="6"/> 
						<xsl:with-param name="styleId" select="(count(preceding-sibling::*[count(.//isSpecificationAttribute)>0]) mod 5) + 1"/>
					</xsl:call-template> 
				</xsl:for-each>
				<xsl:text disable-output-escaping="yes">&lt;/Row&gt;</xsl:text>
			</xsl:if>
		<!--seventh level-->
			<xsl:if test="count(UNICOSMetaModel/*/*/*/*/*/*/*//Attribute[count(isSpecificationAttribute)>0][count(Attribute)=0])>0">
				<xsl:text disable-output-escaping="yes">&lt;Row ss:StyleID="s30UABSTYLE"&gt;</xsl:text>
				<xsl:for-each select="UNICOSMetaModel/Attribute[count(//Attribute[count(isSpecificationAttribute)>0][count(Attribute)=0])>0]|UNICOSMetaModel/AttributeFamily[count(//Attribute[count(isSpecificationAttribute)>0][count(Attribute)=0])>0]">
					<xsl:call-template name="printRow"> 
						<xsl:with-param name="level" select="7"/> 
						<xsl:with-param name="styleId" select="(count(preceding-sibling::*[count(.//isSpecificationAttribute)>0]) mod 5) + 1"/>
					</xsl:call-template> 
				</xsl:for-each>
				<xsl:text disable-output-escaping="yes">&lt;/Row&gt;</xsl:text>
			</xsl:if>
		<!--eighth level-->
			<xsl:if test="count(UNICOSMetaModel/*/*/*/*/*/*/*/*//Attribute[count(isSpecificationAttribute)>0][count(Attribute)=0])>0">
				<xsl:text disable-output-escaping="yes">&lt;Row ss:StyleID="s30UABSTYLE"&gt;</xsl:text>
				<xsl:for-each select="UNICOSMetaModel/Attribute[count(//Attribute[count(isSpecificationAttribute)>0][count(Attribute)=0])>0]|UNICOSMetaModel/AttributeFamily[count(//Attribute[count(isSpecificationAttribute)>0][count(Attribute)=0])>0]">
					<xsl:call-template name="printRow"> 
						<xsl:with-param name="level" select="8"/> 
						<xsl:with-param name="styleId" select="(count(preceding-sibling::*[count(.//isSpecificationAttribute)>0]) mod 5) + 1"/>
					</xsl:call-template> 
				</xsl:for-each>
				<xsl:text disable-output-escaping="yes">&lt;/Row&gt;</xsl:text>
			</xsl:if>
		<!--last level-->
		<xsl:text disable-output-escaping="yes">&lt;Row ss:StyleID="s30UABSTYLE"&gt;</xsl:text>
		<xsl:for-each select="UNICOSMetaModel/AttributeFamily[count(//Attribute[count(Attribute)=0][count(isSpecificationAttribute)>0])>0]">
			<xsl:variable name="pos">
			<xsl:value-of select="(count(preceding-sibling::*[count(.//isSpecificationAttribute)>0]) mod 5) + 1" />
			</xsl:variable>
			<xsl:for-each select=".//Attribute[count(Attribute)=0][count(isSpecificationAttribute)>0]">
				<xsl:text disable-output-escaping="yes">&lt;Cell ss:StyleID="UABSTYLE</xsl:text><xsl:value-of select="$pos"/>
				<xsl:if test="count(isSpecificationAttribute/isValueRequired)>0 and isSpecificationAttribute/isValueRequired = 'true'">
						<xsl:text disable-output-escaping="yes">_Required" ss:IsRequired="true</xsl:text>
				</xsl:if>
				<!-- Add the value for the case sensitive attribute (if defined) -->
				<xsl:if test="count(isSpecificationAttribute/isCaseSensitive)>0 and isSpecificationAttribute/isCaseSensitive = 'true'">
						<xsl:text disable-output-escaping="yes">" ss:IsCaseSensitive="true</xsl:text>
				</xsl:if>
				
				<!-- Add the primitive type for the column -->
				<xsl:choose>
					<xsl:when test="count(isSpecificationAttribute/TypeRepresentation)>0">
						<xsl:text disable-output-escaping="yes">"  ss:PrimitiveType="</xsl:text>
						<xsl:value-of select="isSpecificationAttribute/TypeRepresentation"/>
					</xsl:when>
					<xsl:otherwise>
						<xsl:text disable-output-escaping="yes">"  ss:PrimitiveType="</xsl:text>
						<xsl:value-of select="isSpecificationAttribute/../PrimitiveType"/>
					</xsl:otherwise>
				</xsl:choose>				
				
				<!-- Add the default value -->
				<xsl:if test="count(isSpecificationAttribute/../DefaultValue)>0">
						<xsl:text disable-output-escaping="yes">" ss:DefaultValue="</xsl:text>
						<xsl:value-of select="isSpecificationAttribute/../DefaultValue"/>
				</xsl:if>
				
				<xsl:text disable-output-escaping="yes">"&gt;&lt;Data ss:Type="String"&gt;</xsl:text>
				<xsl:choose>
					<xsl:when test="count(isSpecificationAttribute/NameRepresentation)>0">
						<xsl:value-of select="isSpecificationAttribute/NameRepresentation"/>
					</xsl:when>
					<xsl:otherwise>
						<xsl:value-of select="AttributeName"/>
					</xsl:otherwise>
				</xsl:choose>
				<xsl:text disable-output-escaping="yes">&lt;/Data&gt;</xsl:text>
				<!-- UCPC-627 Comment out comments. Replace with DataValidation InputMessage, see bottom of file.
				<xsl:if test="Description!=''">
					<xsl:text disable-output-escaping="yes">&lt;Comment&gt;&lt;ss:Data xmlns="http://www.w3.org/TR/REC-html40"&gt;</xsl:text><xsl:value-of select="Description"/><xsl:text disable-output-escaping="yes">&lt;/ss:Data&gt;&lt;/Comment&gt;</xsl:text>
				</xsl:if>
				-->
				<xsl:text disable-output-escaping="yes">&lt;/Cell&gt;</xsl:text>
			</xsl:for-each>
		</xsl:for-each>
		<xsl:text disable-output-escaping="yes">&lt;/Row&gt;
		&lt;/Table&gt;
  &lt;WorksheetOptions xmlns="urn:schemas-microsoft-com:office:excel"&gt;
   &lt;Print&gt;
    &lt;ValidPrinterInfo/&gt;
    &lt;PaperSizeIndex&gt;9&lt;/PaperSizeIndex&gt;
    &lt;HorizontalResolution&gt;600&lt;/HorizontalResolution&gt;
    &lt;VerticalResolution&gt;600&lt;/VerticalResolution&gt;
   &lt;/Print&gt;
   &lt;Zoom&gt;75&lt;/Zoom&gt;
   &lt;Selected/&gt;
   &lt;FreezePanes/&gt;
   &lt;FrozenNoSplit/&gt;
   &lt;SplitHorizontal&gt;</xsl:text>   
   
   <xsl:variable name="max-depth-freeze">
		 <xsl:for-each select="//isSpecificationAttribute">
			  <xsl:sort select="count(ancestor::*)" data-type="number"/>
			  <xsl:if test="position()=last()">
			  	<xsl:copy-of select="count(ancestor::*)"/>
			  </xsl:if>
		</xsl:for-each>
   </xsl:variable>
   <xsl:value-of select="$header-start + $max-depth-freeze - 2"/>
   <xsl:text disable-output-escaping="yes">&lt;/SplitHorizontal&gt;
   &lt;TopRowBottomPane&gt;</xsl:text><xsl:value-of select="$header-start  + $max-depth-freeze - 2"/><xsl:text disable-output-escaping="yes">&lt;/TopRowBottomPane&gt;
   &lt;SplitVertical&gt;1&lt;/SplitVertical&gt;
   &lt;LeftColumnRightPane&gt;1&lt;/LeftColumnRightPane&gt;
   &lt;ActivePane&gt;0&lt;/ActivePane&gt;
   &lt;Panes&gt;
    &lt;Pane&gt;
     &lt;Number&gt;3&lt;/Number&gt;
     &lt;ActiveRow&gt;22&lt;/ActiveRow&gt;
     &lt;ActiveCol&gt;5&lt;/ActiveCol&gt;
    &lt;/Pane&gt;
   &lt;/Panes&gt;
   &lt;ProtectObjects&gt;False&lt;/ProtectObjects&gt;
   &lt;ProtectScenarios&gt;False&lt;/ProtectScenarios&gt;
   &lt;AllowSizeCols/&gt;
   &lt;AllowSizeRows/&gt;
   &lt;AllowInsertHyperlinks/&gt;
   &lt;AllowSort/&gt;
   &lt;AllowFilter/&gt;
   &lt;AllowFormatCells/&gt;
   &lt;/WorksheetOptions&gt;
  </xsl:text>
  
		<!-- Data validation: ranges definition (combo box) -->
		<xsl:variable name="startpos" select="11"/>
		<xsl:variable name="max-depth">
		  <xsl:for-each select="//isSpecificationAttribute">
			  <xsl:sort select="count(ancestor::*)" data-type="number"/>
			  <xsl:if test="position()=last()">
			   <xsl:copy-of select="count(ancestor::*)"/>
			  </xsl:if>
			</xsl:for-each>
		</xsl:variable>
		<xsl:for-each select="//isSpecificationAttribute">		

			<!-- Create a combo box for the isSpecificationAttributes where there is a PermittedValue -->
			<xsl:if test="count(./PermittedValue)>=0">	
				<xsl:variable name="length" select="count(.//PermittedValue)"/>
				<xsl:variable name="col" select="count(.//preceding::Attribute[count(.//Attribute)=0][count(isSpecificationAttribute)>0] )"/>				
				<xsl:for-each select="./PermittedValue">
						<xsl:if test="position() = 1">
						<xsl:variable name="previous" select="count(./preceding::PermittedValue)"/>		
							<xsl:text disable-output-escaping="yes">
	&lt;DataValidation xmlns="urn:schemas-microsoft-com:office:excel"&gt;
	&lt;Range&gt;R</xsl:text><xsl:value-of select="$header-start + $max-depth-freeze -1"/><xsl:text disable-output-escaping="yes">C</xsl:text><xsl:value-of select="$col + 1"/><xsl:text disable-output-escaping="yes">:R1048576C</xsl:text><xsl:value-of select="$col + 1"/><xsl:text disable-output-escaping="yes">&lt;/Range&gt;
	&lt;Type&gt;List&lt;/Type&gt;
	&lt;Value&gt;R1C</xsl:text><xsl:value-of select="$startpos + position() - 1 +  $previous"/><xsl:text disable-output-escaping="yes">:R1C</xsl:text><xsl:value-of select="$startpos + position() - 1 +  $previous + $length - 1"/><xsl:text disable-output-escaping="yes">&lt;/Value&gt;
	&lt;/DataValidation&gt;
	
							</xsl:text>
					</xsl:if>
				</xsl:for-each>
			</xsl:if>
			
			<!-- Create the combo box for the boolean primitive types -->
			<xsl:if test="(count(./parent::*[PrimitiveType='BOOLEAN'][.//isSpecificationAttribute[TypeRepresentation='BOOLEAN']])  + 					count(./parent::*[PrimitiveType='BOOLEAN'][count(.//isSpecificationAttribute/TypeRepresentation)=0]) ) >0">
				<xsl:variable name="col" select="count(.//preceding::Attribute[count(.//Attribute)=0][count(isSpecificationAttribute)>0] )"/>
				<xsl:text disable-output-escaping="yes">
	&lt;DataValidation xmlns="urn:schemas-microsoft-com:office:excel"&gt;
	&lt;Range&gt;R</xsl:text><xsl:value-of select="$header-start + $max-depth-freeze -1"/><xsl:text disable-output-escaping="yes">C</xsl:text><xsl:value-of select="$col + 1"/><xsl:text disable-output-escaping="yes">:R1048576C</xsl:text><xsl:value-of select="$col + 1"/><xsl:text disable-output-escaping="yes">&lt;/Range&gt;
	&lt;Type&gt;List&lt;/Type&gt;
	&lt;Value&gt;R1C8:R1C10&lt;/Value&gt;
	&lt;/DataValidation&gt;
	</xsl:text>
			</xsl:if>
			<!-- Create the combo box for the BIT primitive types where the isSpecificationAttribute/TypeRepresentation is BOOLEAN -->
			<xsl:if test="count(./parent::*[PrimitiveType='BIT1'][.//isSpecificationAttribute[TypeRepresentation='BOOLEAN']]) > 0">
				<xsl:variable name="col" select="count(.//preceding::Attribute[count(.//Attribute)=0][count(isSpecificationAttribute)>0] )"/>
				<xsl:text disable-output-escaping="yes">
	&lt;DataValidation xmlns="urn:schemas-microsoft-com:office:excel"&gt;
	&lt;Range&gt;R</xsl:text><xsl:value-of select="$header-start + $max-depth-freeze -1"/><xsl:text disable-output-escaping="yes">C</xsl:text><xsl:value-of select="$col + 1"/><xsl:text disable-output-escaping="yes">:R1048576C</xsl:text><xsl:value-of select="$col + 1"/><xsl:text disable-output-escaping="yes">&lt;/Range&gt;
	&lt;Type&gt;List&lt;/Type&gt;
	&lt;Value&gt;R1C8:R1C10&lt;/Value&gt;
	&lt;/DataValidation&gt;
	</xsl:text>
			</xsl:if>		
		
		</xsl:for-each>

	<!-- UCPC-627 Create DataValidation InputMessage for each cell in last row of Attributes, to replace comments, since formatting is better -->
	<!--NOTE:	InputMessage string is limited to 255 characters. 
					NOTE: Text inside a CDATA section will be ignored by the parser - this is the trick to avoid character transformation, e.g. &amp;, &#10; etc.
					Do it the same way as 'last level' above, i.e. only those Attributes who don't have any children Attributes, i.e. Attribute[count(Attribute)=0]-->
	<xsl:for-each select="UNICOSMetaModel/AttributeFamily[count(//Attribute[count(Attribute)=0][count(isSpecificationAttribute)>0])>0]">
		<xsl:for-each select=".//Attribute[count(Attribute)=0][count(isSpecificationAttribute)>0]">
		<xsl:variable name="col" select="count(.//preceding::Attribute[count(Attribute)=0][count(isSpecificationAttribute)>0] ) + 1"/>
		<xsl:if test="Description!=''">
		<xsl:text disable-output-escaping="yes">
	&lt;DataValidation xmlns="urn:schemas-microsoft-com:office:excel"&gt;
	&lt;Range&gt;R</xsl:text><xsl:value-of select="$header-start + $max-depth-freeze - 2"/><xsl:text disable-output-escaping="yes">C</xsl:text><xsl:value-of select="$col"/><xsl:text disable-output-escaping="yes">&lt;/Range&gt;</xsl:text>
			<xsl:text disable-output-escaping="yes"> 
	&lt;InputMessage&gt;&lt;![CDATA[</xsl:text>
	<xsl:variable name="length_minus_number_of_CRLF">
        <xsl:value-of select="255 - (string-length(Description) - string-length(translate(Description, '&#10;', '')))"/>
	</xsl:variable>  
	<!--Write out string limited to 255-#of CR/LF characters, because substring function counts CRLF (&#10;) characters as 1 character when in DOS they are 2 characters (\r\n) -->
	<xsl:value-of disable-output-escaping="yes" select="substring(Description,1,$length_minus_number_of_CRLF)"/>
	<xsl:text disable-output-escaping="yes">]]&gt;&lt;/InputMessage&gt;</xsl:text>
		<xsl:text disable-output-escaping="yes">
	&lt;/DataValidation&gt;</xsl:text>
		</xsl:if>
	</xsl:for-each>
	</xsl:for-each>

  <!-- Create AutoFilter for all cells from the first cell of data down (because with protected sheets the user can't enable this feature so make it enabled by default) -->
  <xsl:variable name="colMax" select="count(.//Attribute[count(.//Attribute)=0][count(isSpecificationAttribute)>0] )"/>
  <xsl:text disable-output-escaping="yes">
   &lt;x:AutoFilter x:Range="R</xsl:text><xsl:value-of select="$header-start + $max-depth-freeze -2"/><xsl:text disable-output-escaping="yes">C1:R</xsl:text><xsl:value-of select="$header-start + $max-depth-freeze - 2"/><xsl:text disable-output-escaping="yes">C</xsl:text><xsl:value-of select="$colMax"/><xsl:text disable-output-escaping="yes">"
   xmlns="urn:schemas-microsoft-com:office:excel"&gt;
   &lt;/x:AutoFilter&gt;
   </xsl:text>

<xsl:text disable-output-escaping="yes">  
 &lt;/Worksheet&gt;
&lt;/Workbook&gt;
	</xsl:text>	 
	
	</xsl:template>
</xsl:stylesheet>



