package org.xdv.clx.base;

import java.io.IOException;

import org.xdv.clx.builder.ClxBuilderException;
import org.xdv.clx.expr.ClxMacroDefinitions;

/**
 * Macro loader interface.
 * <br>
 * To load external macros required by rules - element {@link ClxConstants#TAG_MACROS}.
 * It is used by {@link ClxValidatorFactory}
 *
 * @author Tomasz Kokoszka
 */
public interface ClxMacroLoader {
    
    /**
     * Loads macro definitions from URL.
     * @param url URL
     * @return macros; !=null
     * @throws ClxBuilderException unable to create macros
     * @throws IOException error while loading data from URL
     */
    public ClxMacroDefinitions loadMacroDefinitions(String url) 
    throws ClxBuilderException, IOException;

}
