package org.xdv.clx.extension;

import org.xdv.clx.exec.ClxExecutionContext;

/**
 * Static error message - CLX extended element implementation.
 * <br>
 * This element is dedicated to generate static validation-error message.
 *
 * @see ClxExtErrorMessage
 * @see ClxExtErrorReport
 * @author Tomasz Kokoszka
 */
public class ClxExtErrorMessageText implements ClxExtErrorMessage {

    /** Static message */
    private final String text;
    
    /**
     * Create static error message.
     * @param text error message
     */
    public ClxExtErrorMessageText(String text) {
        this.text = text;
    }
        
    /**
     * Generate error message - simply returns an internal attribute without any computations.
     * @param cntx CLX execution context (not used by this implementation)
     * @return error message; !=null
     * @see ClxExtErrorMessage#generateMessage(org.xdv.clx.exec.ClxExecutionContext)
     */
    public String generateMessage(ClxExecutionContext cntx) {
        return this.text;
    }
    
    public String toString() {
        return this.text;
    }

}
